<!doctype html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1" />
<meta name="generator" content="pdoc 0.8.1" />
<title>src.gdb_utils API documentation</title>
<meta name="description" content="This file contains some useful functions to operate with a Neo4j database." />
<link href='https://cdnjs.cloudflare.com/ajax/libs/normalize/8.0.0/normalize.min.css' rel='stylesheet'>
<link href='https://cdnjs.cloudflare.com/ajax/libs/10up-sanitize.css/8.0.0/sanitize.min.css' rel='stylesheet'>
<link href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" rel="stylesheet">
<style>.flex{display:flex !important}body{line-height:1.5em}#content{padding:20px}#sidebar{padding:30px;overflow:hidden}#sidebar > *:last-child{margin-bottom:2cm}.http-server-breadcrumbs{font-size:130%;margin:0 0 15px 0}#footer{font-size:.75em;padding:5px 30px;border-top:1px solid #ddd;text-align:right}#footer p{margin:0 0 0 1em;display:inline-block}#footer p:last-child{margin-right:30px}h1,h2,h3,h4,h5{font-weight:300}h1{font-size:2.5em;line-height:1.1em}h2{font-size:1.75em;margin:1em 0 .50em 0}h3{font-size:1.4em;margin:25px 0 10px 0}h4{margin:0;font-size:105%}a{color:#058;text-decoration:none;transition:color .3s ease-in-out}a:hover{color:#e82}.title code{font-weight:bold}h2[id^="header-"]{margin-top:2em}.ident{color:#900}pre code{background:#f8f8f8;font-size:.8em;line-height:1.4em}code{background:#f2f2f1;padding:1px 4px;overflow-wrap:break-word}h1 code{background:transparent}pre{background:#f8f8f8;border:0;border-top:1px solid #ccc;border-bottom:1px solid #ccc;margin:1em 0;padding:1ex}#http-server-module-list{display:flex;flex-flow:column}#http-server-module-list div{display:flex}#http-server-module-list dt{min-width:10%}#http-server-module-list p{margin-top:0}.toc ul,#index{list-style-type:none;margin:0;padding:0}#index code{background:transparent}#index h3{border-bottom:1px solid #ddd}#index ul{padding:0}#index h4{margin-top:.6em;font-weight:bold}@media (min-width:200ex){#index .two-column{column-count:2}}@media (min-width:300ex){#index .two-column{column-count:3}}dl{margin-bottom:2em}dl dl:last-child{margin-bottom:4em}dd{margin:0 0 1em 3em}#header-classes + dl > dd{margin-bottom:3em}dd dd{margin-left:2em}dd p{margin:10px 0}.name{background:#eee;font-weight:bold;font-size:.85em;padding:5px 10px;display:inline-block;min-width:40%}.name:hover{background:#e0e0e0}.name > span:first-child{white-space:nowrap}.name.class > span:nth-child(2){margin-left:.4em}.inherited{color:#999;border-left:5px solid #eee;padding-left:1em}.inheritance em{font-style:normal;font-weight:bold}.desc h2{font-weight:400;font-size:1.25em}.desc h3{font-size:1em}.desc dt code{background:inherit}.source summary,.git-link-div{color:#666;text-align:right;font-weight:400;font-size:.8em;text-transform:uppercase}.source summary > *{white-space:nowrap;cursor:pointer}.git-link{color:inherit;margin-left:1em}.source pre{max-height:500px;overflow:auto;margin:0}.source pre code{font-size:12px;overflow:visible}.hlist{list-style:none}.hlist li{display:inline}.hlist li:after{content:',\2002'}.hlist li:last-child:after{content:none}.hlist .hlist{display:inline;padding-left:1em}img{max-width:100%}.admonition{padding:.1em .5em;margin-bottom:1em}.admonition-title{font-weight:bold}.admonition.note,.admonition.info,.admonition.important{background:#aef}.admonition.todo,.admonition.versionadded,.admonition.tip,.admonition.hint{background:#dfd}.admonition.warning,.admonition.versionchanged,.admonition.deprecated{background:#fd4}.admonition.error,.admonition.danger,.admonition.caution{background:lightpink}</style>
<style media="screen and (min-width: 700px)">@media screen and (min-width:700px){#sidebar{width:30%;height:100vh;overflow:auto;position:sticky;top:0}#content{width:70%;max-width:100ch;padding:3em 4em;border-left:1px solid #ddd}pre code{font-size:1em}.item .name{font-size:1em}main{display:flex;flex-direction:row-reverse;justify-content:flex-end}.toc ul ul,#index ul{padding-left:1.5em}.toc > ul > li{margin-top:.5em}}</style>
<style media="print">@media print{#sidebar h1{page-break-before:always}.source{display:none}}@media print{*{background:transparent !important;color:#000 !important;box-shadow:none !important;text-shadow:none !important}a[href]:after{content:" (" attr(href) ")";font-size:90%}a[href][title]:after{content:none}abbr[title]:after{content:" (" attr(title) ")"}.ir a:after,a[href^="javascript:"]:after,a[href^="#"]:after{content:""}pre,blockquote{border:1px solid #999;page-break-inside:avoid}thead{display:table-header-group}tr,img{page-break-inside:avoid}img{max-width:100% !important}@page{margin:0.5cm}p,h2,h3{orphans:3;widows:3}h1,h2,h3,h4,h5,h6{page-break-after:avoid}}</style>
</head>
<body>
<main>
<article id="content">
<header>
<h1 class="title">Module <code>src.gdb_utils</code></h1>
</header>
<section id="section-intro">
<p>This file contains some useful functions to operate with a Neo4j database.</p>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">&#34;&#34;&#34;This file contains some useful functions to operate with a Neo4j database.
&#34;&#34;&#34;

from py2neo import Graph
import getpass
from src.config import DB_URL, DB_NAME
from neo4j import GraphDatabase
import pandas as pd

def connect_to_database_py2neo(db_url=DB_URL):
    &#34;&#34;&#34;Connects to a Neo4j database and returns the contained graph using py2neo.

    This function does not support the feature to select a database out of
    multiple databases which is a feature in Neo4j 4.0.x.

    The url of the databasd is specified by `DB_URL`. Calling this function
    opens a prompt for inserting username and password.

    Parameters
    ----------
    db_url: str
        The URL of the database we want to operate on. By default this is the
        url of our pid database.

    Returns
    -------
    py2neo.Graph
        The graph contained in the database.

    &#34;&#34;&#34;
    graph = Graph(DB_URL, auth=(getpass.getpass(prompt=&#39;User: &#39;), getpass.getpass(prompt=&#39;Password: &#39;)))

    return graph



def connect_to_database(db_url=DB_URL, db_name=DB_NAME):
    &#34;&#34;&#34;Connects to a Neo4j database and returns the driver and its session

    The url of the databasd is specified by `DB_URL`. Calling this function
    opens a prompt for inserting username and password.

    Parameters
    ----------
    db_url: str
        The URL of the database we want to operate on. By default this is the
        url of our pid database.
    db_name: str
        The name of the database we want to select. By default this is the name
        of the pid database

    Returns
    -------
    neo4j.Driver
        The driver that connects to the database

    neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session
    &#34;&#34;&#34;
    driver = GraphDatabase.driver(DB_URL, auth=(getpass.getpass(prompt=&#39;User: &#39;), getpass.getpass(prompt=&#39;Password: &#39;)))
    mydb = driver.session(database=DB_NAME)
    return driver, mydb



def run_query_py2neo(graph: Graph, query: str):
    &#34;&#34;&#34;Runs the specified query on the Neo4j database and returns the result.

    This works well for simple queries returning a single value, e.g. an int.
    For queries returning a dataframe, use the method `run_query_dataframe`.

    Parameters
    ----------
    graph: py2neo.Graph
        the graph on which the query should be run
    query: str
        a Cypher query

    Returns
    -------
    some type
        The evaluation of the given query. This can be e.g. an int or a list
        depending on the query.

    &#34;&#34;&#34;

    return graph.evaluate(query)


def run_query_py2neo_dataframe(graph: Graph, query: str):
    &#34;&#34;&#34;Runs the specified query on the Neo4j database and returns the result.

    This works for queries returning a dataframe.

    Parameters
    ----------
    graph: py2neo.Graph
        the graph on which the query should be run
    query: str
        the query to be executed

    Returns
    -------
    dataframe
        the evaluation of the given query.

    &#34;&#34;&#34;
    df = graph.run(query).to_data_frame()
    return df

def run_query(session, query:str, read=True, suppress_output=False):
    &#34;&#34;&#34;Runs cypher query on database and prints result.

    Parameters
    ----------
    session: neo4j.Session
        The current session object of the used to driver
    query: str
        a Cypher query
    read: bool
        if true the given query is executed as a read_transaction, otherwise as
        a write_transaction
    suppress_output: bool
        if true, the default output of the result will be suppressed. 
        Per default this is set false.

    Returns
    -------
    pandas dataframe
        The result of the executed query
    &#34;&#34;&#34;

    def execute(tx, cypher):
        if not suppress_output:
            print(&#34;Executing query \&#39;{}\&#39;...&#34;.format(cypher))
        data = tx.run(cypher)
        res = pd.DataFrame([r.values() for r in data], columns=data.keys())
        return res

    if read:
        result = session.read_transaction(execute, query)
    else:
        result = session.write_transaction(execute, query)

    if not suppress_output:
        print(&#34;\n-------------------------------------\n-------------- Result: --------------\n-------------------------------------\n&#34;)
        print(result)
        
    return result</code></pre>
</details>
</section>
<section>
</section>
<section>
</section>
<section>
<h2 class="section-title" id="header-functions">Functions</h2>
<dl>
<dt id="src.gdb_utils.connect_to_database"><code class="name flex">
<span>def <span class="ident">connect_to_database</span></span>(<span>db_url='bolt+ssc://graphdb.gwdg.de:7687', db_name='pidgraph')</span>
</code></dt>
<dd>
<div class="desc"><p>Connects to a Neo4j database and returns the driver and its session</p>
<p>The url of the databasd is specified by <code>DB_URL</code>. Calling this function
opens a prompt for inserting username and password.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>db_url</code></strong> :&ensp;<code>str</code></dt>
<dd>The URL of the database we want to operate on. By default this is the
url of our pid database.</dd>
<dt><strong><code>db_name</code></strong> :&ensp;<code>str</code></dt>
<dd>The name of the database we want to select. By default this is the name
of the pid database</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>neo4j.Driver</code></dt>
<dd>The driver that connects to the database</dd>
<dt><code>neo4j.Session (&lt;https://neo4j.com/docs/api/python-driver/current/api.html#session&gt;)</code></dt>
<dd>The session object of the started session</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def connect_to_database(db_url=DB_URL, db_name=DB_NAME):
    &#34;&#34;&#34;Connects to a Neo4j database and returns the driver and its session

    The url of the databasd is specified by `DB_URL`. Calling this function
    opens a prompt for inserting username and password.

    Parameters
    ----------
    db_url: str
        The URL of the database we want to operate on. By default this is the
        url of our pid database.
    db_name: str
        The name of the database we want to select. By default this is the name
        of the pid database

    Returns
    -------
    neo4j.Driver
        The driver that connects to the database

    neo4j.Session (https://neo4j.com/docs/api/python-driver/current/api.html#session)
        The session object of the started session
    &#34;&#34;&#34;
    driver = GraphDatabase.driver(DB_URL, auth=(getpass.getpass(prompt=&#39;User: &#39;), getpass.getpass(prompt=&#39;Password: &#39;)))
    mydb = driver.session(database=DB_NAME)
    return driver, mydb</code></pre>
</details>
</dd>
<dt id="src.gdb_utils.connect_to_database_py2neo"><code class="name flex">
<span>def <span class="ident">connect_to_database_py2neo</span></span>(<span>db_url='bolt+ssc://graphdb.gwdg.de:7687')</span>
</code></dt>
<dd>
<div class="desc"><p>Connects to a Neo4j database and returns the contained graph using py2neo.</p>
<p>This function does not support the feature to select a database out of
multiple databases which is a feature in Neo4j 4.0.x.</p>
<p>The url of the databasd is specified by <code>DB_URL</code>. Calling this function
opens a prompt for inserting username and password.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>db_url</code></strong> :&ensp;<code>str</code></dt>
<dd>The URL of the database we want to operate on. By default this is the
url of our pid database.</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>py2neo.Graph</code></dt>
<dd>The graph contained in the database.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def connect_to_database_py2neo(db_url=DB_URL):
    &#34;&#34;&#34;Connects to a Neo4j database and returns the contained graph using py2neo.

    This function does not support the feature to select a database out of
    multiple databases which is a feature in Neo4j 4.0.x.

    The url of the databasd is specified by `DB_URL`. Calling this function
    opens a prompt for inserting username and password.

    Parameters
    ----------
    db_url: str
        The URL of the database we want to operate on. By default this is the
        url of our pid database.

    Returns
    -------
    py2neo.Graph
        The graph contained in the database.

    &#34;&#34;&#34;
    graph = Graph(DB_URL, auth=(getpass.getpass(prompt=&#39;User: &#39;), getpass.getpass(prompt=&#39;Password: &#39;)))

    return graph</code></pre>
</details>
</dd>
<dt id="src.gdb_utils.run_query"><code class="name flex">
<span>def <span class="ident">run_query</span></span>(<span>session, query: str, read=True, suppress_output=False)</span>
</code></dt>
<dd>
<div class="desc"><p>Runs cypher query on database and prints result.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>session</code></strong> :&ensp;<code>neo4j.Session</code></dt>
<dd>The current session object of the used to driver</dd>
<dt><strong><code>query</code></strong> :&ensp;<code>str</code></dt>
<dd>a Cypher query</dd>
<dt><strong><code>read</code></strong> :&ensp;<code>bool</code></dt>
<dd>if true the given query is executed as a read_transaction, otherwise as
a write_transaction</dd>
<dt><strong><code>suppress_output</code></strong> :&ensp;<code>bool</code></dt>
<dd>if true, the default output of the result will be suppressed.
Per default this is set false.</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>pandas dataframe</code></dt>
<dd>The result of the executed query</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def run_query(session, query:str, read=True, suppress_output=False):
    &#34;&#34;&#34;Runs cypher query on database and prints result.

    Parameters
    ----------
    session: neo4j.Session
        The current session object of the used to driver
    query: str
        a Cypher query
    read: bool
        if true the given query is executed as a read_transaction, otherwise as
        a write_transaction
    suppress_output: bool
        if true, the default output of the result will be suppressed. 
        Per default this is set false.

    Returns
    -------
    pandas dataframe
        The result of the executed query
    &#34;&#34;&#34;

    def execute(tx, cypher):
        if not suppress_output:
            print(&#34;Executing query \&#39;{}\&#39;...&#34;.format(cypher))
        data = tx.run(cypher)
        res = pd.DataFrame([r.values() for r in data], columns=data.keys())
        return res

    if read:
        result = session.read_transaction(execute, query)
    else:
        result = session.write_transaction(execute, query)

    if not suppress_output:
        print(&#34;\n-------------------------------------\n-------------- Result: --------------\n-------------------------------------\n&#34;)
        print(result)
        
    return result</code></pre>
</details>
</dd>
<dt id="src.gdb_utils.run_query_py2neo"><code class="name flex">
<span>def <span class="ident">run_query_py2neo</span></span>(<span>graph: py2neo.database.Graph, query: str)</span>
</code></dt>
<dd>
<div class="desc"><p>Runs the specified query on the Neo4j database and returns the result.</p>
<p>This works well for simple queries returning a single value, e.g. an int.
For queries returning a dataframe, use the method <code>run_query_dataframe</code>.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>graph</code></strong> :&ensp;<code>py2neo.Graph</code></dt>
<dd>the graph on which the query should be run</dd>
<dt><strong><code>query</code></strong> :&ensp;<code>str</code></dt>
<dd>a Cypher query</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>some type</code></dt>
<dd>The evaluation of the given query. This can be e.g. an int or a list
depending on the query.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def run_query_py2neo(graph: Graph, query: str):
    &#34;&#34;&#34;Runs the specified query on the Neo4j database and returns the result.

    This works well for simple queries returning a single value, e.g. an int.
    For queries returning a dataframe, use the method `run_query_dataframe`.

    Parameters
    ----------
    graph: py2neo.Graph
        the graph on which the query should be run
    query: str
        a Cypher query

    Returns
    -------
    some type
        The evaluation of the given query. This can be e.g. an int or a list
        depending on the query.

    &#34;&#34;&#34;

    return graph.evaluate(query)</code></pre>
</details>
</dd>
<dt id="src.gdb_utils.run_query_py2neo_dataframe"><code class="name flex">
<span>def <span class="ident">run_query_py2neo_dataframe</span></span>(<span>graph: py2neo.database.Graph, query: str)</span>
</code></dt>
<dd>
<div class="desc"><p>Runs the specified query on the Neo4j database and returns the result.</p>
<p>This works for queries returning a dataframe.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>graph</code></strong> :&ensp;<code>py2neo.Graph</code></dt>
<dd>the graph on which the query should be run</dd>
<dt><strong><code>query</code></strong> :&ensp;<code>str</code></dt>
<dd>the query to be executed</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>dataframe</code></dt>
<dd>the evaluation of the given query.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def run_query_py2neo_dataframe(graph: Graph, query: str):
    &#34;&#34;&#34;Runs the specified query on the Neo4j database and returns the result.

    This works for queries returning a dataframe.

    Parameters
    ----------
    graph: py2neo.Graph
        the graph on which the query should be run
    query: str
        the query to be executed

    Returns
    -------
    dataframe
        the evaluation of the given query.

    &#34;&#34;&#34;
    df = graph.run(query).to_data_frame()
    return df</code></pre>
</details>
</dd>
</dl>
</section>
<section>
</section>
</article>
<nav id="sidebar">
<h1>Index</h1>
<div class="toc">
<ul></ul>
</div>
<ul id="index">
<li><h3>Super-module</h3>
<ul>
<li><code><a title="src" href="index.html">src</a></code></li>
</ul>
</li>
<li><h3><a href="#header-functions">Functions</a></h3>
<ul class="">
<li><code><a title="src.gdb_utils.connect_to_database" href="#src.gdb_utils.connect_to_database">connect_to_database</a></code></li>
<li><code><a title="src.gdb_utils.connect_to_database_py2neo" href="#src.gdb_utils.connect_to_database_py2neo">connect_to_database_py2neo</a></code></li>
<li><code><a title="src.gdb_utils.run_query" href="#src.gdb_utils.run_query">run_query</a></code></li>
<li><code><a title="src.gdb_utils.run_query_py2neo" href="#src.gdb_utils.run_query_py2neo">run_query_py2neo</a></code></li>
<li><code><a title="src.gdb_utils.run_query_py2neo_dataframe" href="#src.gdb_utils.run_query_py2neo_dataframe">run_query_py2neo_dataframe</a></code></li>
</ul>
</li>
</ul>
</nav>
</main>
<footer id="footer">
<p>Generated by <a href="https://pdoc3.github.io/pdoc"><cite>pdoc</cite> 0.8.1</a>.</p>
</footer>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
<script>hljs.initHighlightingOnLoad()</script>
</body>
</html>